
C$ 28.02.89
C***********************************************************************

      SUBROUTINE PLOTR(X,Y,XA,YA,XI,YI,NPOI,OUT,ID,LONG)
C     ================

C  PLOT ROUTINE FOR ALSCAL
C  -----------------------
C  THE ORIGINAL PLOT ROUTINE BY F.W. YOUNG HAS BEEN COMPLETELY REWRITTEN
C  BY B.ERICHSON / A.BISCHOFF, JAN. 89, FOR RUNNING ALSCAL ON PC.
C  PLOTR NOW SERVES AS A CALLING ROUTINE FOR THE NEW PLOT ROUTINE PPLOT.

C-----------------------------------------------------------------------

      INTEGER OUT
      CHARACTER*72,COPR
      COMMON /CCOPR/COPR
      DIMENSION X(LONG),Y(LONG)

C---THE FOLLOWING THREE LINES ARE SAS ONLY LINES
C     COMMON /IOUNIT/LOUT
C    +       /PAGE/NLINES
C     OUT = LOUT

C---THE FOLLOWING LINE IS STAND ALONE ONLY
      NLINES=60


C  PAGE SIZE: NLINES x NCOLUM
      NCOLUM=120


C  OUTPUT ON SCREEN
C  ================
      OPEN (99,FILE='CON')
      IOUT=99
      IH = 27
      IW = 80

      CALL PPLOT (X,Y,NPOI,XI,XA,YI,YA,ID,IOUT,IH,IW)

      WRITE (*,21)
   21 FORMAT (T2,'Hit <RETURN>',T76,'X')
      READ*
      CALL CLEAR


C  OUTPUT FOR PRINTER
C  ==================
      IOUT=OUT
      IH = NLINES
      IW = NCOLUM

C  ADJUST PRINTER
C  --------------
C  NEAR LETTER QUALITY ON
C     WRITE (IOUT,10) CHAR(27),'x','1'
C  10 FORMAT (3A1)

      CALL PPLOT (X,Y,NPOI,XI,XA,YI,YA,ID,IOUT,IH,IW)

      WRITE (IOUT,32)
   32 FORMAT (T115,'X')

C  READJUST PRINTER
C  ----------------
C  NLQ OFF
C     WRITE (IOUT,10) CHAR(27),'x','0'

      RETURN
      END


C***********************************************************************

      SUBROUTINE PPLOT (X,Y,NPOINT,X1,X2,Y1,Y2,MODUS,IOUT,IH,IW)
C     ================

C  PLOT ROUTINE FOR ALSCAL
C  -----------------------

C  THE ROUTINE GENERATES A PRINTER PLOT OF ARRAY -X- VS. ARRAY -Y-.

C    X(NPOINT) : X-COORDINATES
C    Y(NPOINT) : Y-COORDINATES

C       X1, X2 : BOUNDS FOR X-AXIS
C       Y1, Y2 : BOUNDS FOR Y-AXIS

C       X-BOUNDS ARE GENERATED IF X1 = X2
C       Y-BOUNDS ARE GENERATED IF Y1 = Y2

C    MODUS > 0 : AXES WILL BE INCLUDED
C          < 0 : NO AXES WILL BE INCLUDED
C           1 : POINTS WILL BE COUNTED
C           2 : POINTS WILL BE IDENTIFIED

C         IOUT : OUTPUT UNIT
C           IH : LENGTH OF PAGE
C           IW : WIDTH  OF PAGE


C  IF VECTOR X EQUALS VECTOR Y THEN POINTS WILL BE PLOTTED ALONG
C  THE HORIZONTAL AXIS (NO AXES WILL BE PLOTTED)


C  THERE CAN BE ONE OR TWO SETS OF POINTS:

C   NCOL = NROW = NPOINT  ->  ONE SET :   X  Y      (PLOT:  A,B,C,...)

C   NCOL + NROW = NPOINT  ->  TWO SETS:

C                     - COLUMN STIMULI    X1 Y1     (PLOT:  a,b,c,...)
C                                         -----
C                     - ROW STIMULI       X2 Y2     (PLOT:  A,B,C,...)

C-----------------------------------------------------------------------

C  DEFINE MAX. SIZE OF PLOT FIELD
      PARAMETER( MAXX = 101, MAXY = 101)
      PARAMETER( MXY = MAXX*MAXY, MAXX2 = MAXX+14)

C  DEFINE NO. OF INTERVALS ON X-AXIS AND Y-AXIS ( 6  NINT  10 )
      PARAMETER (NINTX = 10, NINTY = 10)

      LOGICAL AXES,TWOSET,ONEDIM
      CHARACTER*1 FELD(MAXX,MAXY),LINE(MAXX2)
      CHARACTER FELD1*MXY,FELD2(MAXY)*MAXX,LINE1*MAXX2
      CHARACTER*1 ALFA(52),ALFAL(26),ALFAS(26),SYMB(10),CHAR1
      CHARACTER ALFA1*52,SYMB1*10,FFORM*13
      CHARACTER*1 BLANK,BAR,IBAR,LIO,REO,LIU,REU,TIL,TIR,TIU,CROSS

      DIMENSION X(NPOINT),Y(NPOINT),XVALUE(NINTX+1)

      EQUIVALENCE (FELD,FELD1,FELD2),(LINE,LINE1),(SYMB,SYMB1)
      EQUIVALENCE(ALFA,ALFA1),(ALFA1(1:26),ALFAL),(ALFA1(27:52),ALFAS)

      COMMON /CPPLOT/NROW

      DATA SYMB1/'X23456789M'/
      DATA ALFA1/'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'/
      DATA BLANK,BAR,IBAR,LIO,REO,LIU,REU,TIL,TIR,TIU,CROSS
     +     /' ','','','','','','','','','',''/

	AXES =.FALSE.
	TWOSET =.FALSE.
	IF (NROW.LT.NPOINT) THEN
	  TWOSET =.TRUE.
	  NCOL=NPOINT-NROW
	END IF


C  PLOT DESIGN
C  -----------
C  IW x IH : SIZE OF PAGE           (GIVEN FROM CALLING ROUTINE)
C  NX x NY : SIZE OF PLOT FIELD
C    NINTX : INTERVALS ON X-AXIS
C    NINTY : INTERVALS ON Y-AXIS
C      IIX : SPACES PER INTERVAL ON X-AXIS
C      IIY : SPACES PER INTERVAL ON Y-AXIS

CIW
C HEADER                                                                    IH
C ------                                                                     
C<----14----><------------------------- NX  MAXX -----------------------><2>
C             
C       1.0                                   I                           
C       0.8                                   I                           
C       0.6      PLOT FIELD                   I NY  MAXY                 
C       0.4                                   I                           
C       0.2                                   I                           
C       0.0 I  
C      -0.2                                   I                           
C      -0.4                                   I                           
C      -0.6                                   I                           
C      -0.8                                   I                           
C      -1.0                                   I                           
C             
C          -1.0  -0.8  -0.6  -0.4  -0.2   0.0   0.2   0.4   0.6   0.8   1.0  
C


C  SIZE OF PLOT FIELD
C  ------------------
      NX = IW - 15
      NY = IH -  6

      NX = MIN0(MAXX,NX)
      NY = MIN0(MAXY,NY)

      IIX = (NX-1)/NINTX
      IIY = (NY-1)/NINTY

      NX = IIX * NINTX + 1
      NY = IIY * NINTY + 1

      MIDX = NX/2 + 1
      MIDY = NY/2 + 1


C  CLEAR PLOT FIELD
C  ----------------
      FELD1=BLANK
      LINE1=BLANK



C  CHECK TO SEE IF ONE DIMENSIONAL PLOT
C  ------------------------------------
      ONEDIM=.FALSE.
      DO 101 I=1,NPOINT
      IF(X(I).NE.Y(I))GOTO 110
  101 CONTINUE
      ONEDIM=.TRUE.


C  IF DESIRED, INCLUDE AXES ON CENTER OF PLOT
C  ------------------------------------------
  110 IF (.NOT.ONEDIM) THEN
	IF (MODUS.GT.0) THEN
	  AXES=.TRUE.
	  DO 111 I=1,NY
  111     FELD(MIDX,I)=IBAR
	  DO 112 I=1,NX
  112     FELD(I,MIDY)=BAR
	  FELD(MIDX,MIDY)=CROSS
	END IF
      END IF

C  DETERMINE MINIMA AND MAXIMA, IF NECESSARY
C  -----------------------------------------
C  X-AXIS
      XMIN=X1
      YMIN=Y1
      XMAX=X2
      YMAX=Y2
      IF (XMAX.EQ.XMIN) THEN
	XMIN = X(1)
	XMAX = XMIN
	DO 121 I = 2,NPOINT
	  IF (X(I).LT.XMIN) XMIN=X(I)
	  IF (X(I).GT.XMAX) XMAX=X(I)
  121   CONTINUE

	IF (AXES) THEN
C  MAKE RANGE SYMMETRIC AROUND ZERO
	  ZMAX = AMAX1(ABS(XMIN),ABS(XMAX))
	  XMIN = -ZMAX
	  XMAX =  ZMAX
	END IF

      END IF

C  Y-AXIS
      IF (YMAX.EQ.YMIN) THEN
	YMIN = Y(1)
	YMAX = YMIN
	DO 122 I = 2,NPOINT
	  IF (Y(I).LT.YMIN) YMIN=Y(I)
	  IF (Y(I).GT.YMAX) YMAX=Y(I)
  122   CONTINUE

	IF (AXES) THEN
C  MAKE RANGE SYMMETRIC AROUND ZERO
	  ZMAX = AMAX1(ABS(YMIN),ABS(YMAX))
	  YMIN = -ZMAX
	  YMAX =  ZMAX
	END IF

      END IF


      IF (IABS(MODUS).EQ.1) THEN
	IF (XMIN.LE.0.0) XMIN=.00001
	IF (YMIN.LE.0.0) YMIN=.00001
      END IF


C  DETERMINE RANGE AND INCREMENT OF BOTH AXES
C  ------------------------------------------
      SPANX = XMAX-XMIN
      SPANY = YMAX-YMIN
      DELX  = SPANX/(NX-1)
      DELY  = SPANY/(NY-1)


C  ENTER POINTS INTO PLOT
C  ----------------------
      DO 200 II=1,NPOINT

C  LOCATE POINT: (X,Y) -> (J,I)
	IF (ONEDIM) THEN
	  I=MIDY
	ELSE
	  I=(YMAX-Y(II))/DELY+1.5
	  IF (I.GT.NY.OR.I.LT.1) GOTO 200
	END IF
	J=(X(II)-XMIN)/DELX+1.5

	IF (J.GT.NX.OR.J.LT.1) GOTO 200


	IF(IABS(MODUS).EQ.2) THEN

C  IDENTIFY POINT
	  IF (TWOSET) THEN
	    IF(II.LE.NCOL) THEN
	      KK=MOD(II-1,26)+1
	      FELD(J,I)=ALFAS(KK)
	    ELSE
	      KK=MOD(II-NCOL-1,26)+1
	      FELD(J,I)=ALFAL(KK)
	    END IF
	  ELSE
	    KK=MOD(II-1,52)+1
	    FELD(J,I)=ALFA(KK)
	  END IF
	ELSE

C  COUNT POINT
	  CHAR1=FELD(J,I)
	  IF (CHAR1.EQ.BLANK.OR.CHAR1.EQ.BAR.OR.CHAR1.EQ.IBAR.OR.
     +      CHAR1.EQ.CROSS) THEN
	    FELD(J,I)=SYMB(1)
	  ELSE
	    DO 201 JJ=1,10
	    IF (CHAR1.EQ.SYMB(JJ)) THEN
	      JJ1=MIN0(JJ+1,10)
	      GOTO 202
	    END IF
  201       CONTINUE
  202       FELD(J,I)=SYMB(JJ1)
	  END IF
	END IF

  200 CONTINUE


C PRINT PLOT
C ----------
C TOP OF FRAME
      DO 203 I=14,NX+13
  203 LINE(I)=BAR
      LINE(4)='Y'
      LINE(13)=LIO
      LINE(NX+14)=REO
      LINE(MIDX+13)=TIU
      WRITE(IOUT,300) LINE1(1:NX+14)
  300 FORMAT(1X,A)


C  CYCLUS OVER LINES
      VALUE = YMAX+DELY
      DO 310 I=1,NY
	VALUE=VALUE-DELY
	L=I+IIY-1
	IF (L/IIY*IIY.EQ.L) THEN
	  IF (AXES.AND.I.EQ.MIDY) THEN
	    WRITE(IOUT,311) VALUE,CROSS,FELD2(I)(1:NX),CROSS
	  ELSE
	    WRITE(IOUT,311) VALUE,TIL,FELD2(I)(1:NX),TIR
	  END IF
  311     FORMAT(' ',F11.1,' ',4A)
	ELSE
	  WRITE(IOUT,312) IBAR,FELD2(I)(1:NX),IBAR
  312     FORMAT(13X,3A)
	END IF
  310 CONTINUE


C  BOTTOM OF FRAME
      DO 320 J=1,NX
	L=J+IIX-1
	IF (L/IIX*IIX.EQ.L) LINE(J+13)=TIU
  320 CONTINUE
      LINE(4)=BLANK
      LINE(13)=LIU
      LINE(NX+14)=REU
      LINE(MIDX+13)=CROSS
      WRITE(IOUT,300) LINE1(1:NX+14)

C  LABELS FOR X-AXIS
      XVALUE(1) = XMIN
      DO 330 I=1,NINTX
  330 XVALUE(I+1)=XVALUE(I)+IIX*DELX

C  FORMAT FOR LABELS (E.G.: '(10X,11F06.1)')
      IIX1=14-IIX+2
      WRITE (FFORM,331) IIX1,IIX
  331 FORMAT ('(',I2,'X,11F',I2,'.1)')

      WRITE(IOUT,FFORM) (XVALUE(I),I=1,NINTX+1)

      RETURN
      END

